#include <QDebug>

#include "MainQ.hpp"

#define PS1_CHROME "Get-Process -Name chrome"
#define PS1_TEAMS "Get-Process -Name Teams"

#define PS1_NOW \
"$date=(Get-Date); Write-Output $(\"{0,4:d4}-{1,2:d2}-{2,2:d2} {3,2:d2}:{4,2" \
":d2}:{5,2:d2}.{6,3:d3}\" -f ($date.Year, $date.Month, $date.Day, $date.Hour" \
", $date.Minute, $date.Second, $date.Millisecond))"


// Full : CRASH
#define COMPUTERSANDUSERS_PS1 \
"function abort($code, $desc) {$json='{\"errorCode\":'+$code+',\"errorDesc\"" \
":\"'+$desc+'\",\"allComputers\":[],\"allUsers\":{}}';write-output $json;exi" \
"t;}function ldapID($dn) {$rep=@();$rdn=$dn -split ',';foreach($r in $rdn){$" \
"nv=$r -split '=';$rep+=,@($nv[0],$nv[1]);}$rep;}$computersdn=(Get-ADCompute" \
"r -Filter * -SearchBase \"OU=Workstation,OU=MyApp,DC=mydomain,DC=local\").D" \
"istinguishedName;if(-not $?){abort 1 \"Error in Get-ADComputer\";}if($compu" \
"tersdn.Length -eq 0){$allComputers='';}else{$_allComputers=@();foreach($cdn" \
" in $computersdn){$c=ldapID $cdn;if($c[0][0] -ne 'CN' -or $c[1][0] -ne 'OU'" \
"){abort 2 \"Invalid LDAP name\";}$computerName=$c[0][1];$loggedOnUser=(Get-" \
"WmiObject -ComputerName \"$computerName\" -Class Win32_ComputerSystem).User" \
"Name;if(-not $?){abort 3 \"Error in Get-WmiObject\";}$ipAddress=(Get-ADComp" \
"uter -Filter \"Name -eq '$computerName'\" -Properties IPv4Address).Ipv4Addr" \
"ess;if(-not $?) {abort 5 \"Error in Get-ADComputer\";}if ($loggedOnUser.Len" \
"gth -gt 0 -and $loggedOnUser.LastIndexOf('\') -ge 0){$loggedOnUser=$loggedO" \
"nUser.Substring($loggedOnUser.LastIndexOf('\') + 1);}$_allComputers+='{\"na" \
"me\":\"'+$computerName+'\",\"ipAddress\":\"'+$ipAddress+'\",\"role\":\"'+$c" \
"[1][1]+'\",\"loggedOnUser\":\"'+$loggedOnUser+'\"}';}$allComputers=$_allCom" \
"puters -join ',';}$users=(Get-ADUser -Filter * -SearchBase \"OU=ADU,OU=User" \
",OU=MyApp,DC=mydomain,DC=local\");if(-not $?){abort 6 \"Error in Get-ADUser" \
"\";}if($users.Length -eq 0){$allUsers='';}else{$_allUsers=@();foreach($usr " \
"in $users){$userName=$usr.UserPrincipalName.Substring(0, $usr.UserPrincipal" \
"Name.IndexOf('@'));$ldapName=$usr.DistinguishedName;$u=ldapID $ldapName;if(" \
"$u[0][0] -ne 'CN'){abort 7 \"Invalid LDAP name\";}$fullName=$u[0][1];$group" \
"sdn=(Get-ADPrincipalGroupMembership -Identity \"$ldapName\").DistinguishedN" \
"ame;if(-not $?){abort 8 \"Error in Get-ADPrincipalGroupMembership\";}if($gr" \
"oupsdn.Length -eq 0){$userRoles='';}else{$_userRoles=@();foreach($gdn in $g" \
"roupsdn){$g=ldapID $gdn;if($g[0][0] -ne 'CN'){abort 9 \"Invalid LDAP name\"" \
";}$_userRoles+=$g[0][1];}$userRoles='\"'+($_userRoles -join '\",\"')+'\"';}" \
"$_allUsers+='\"'+$userName+'\":{\"name\":\"'+$fullName+'\",\"roles\":['+$us" \
"erRoles+']}';}$allUsers=$_allUsers -join ',';}$json='{\"errorCode\":0,\"err" \
"orDesc\":\"\",\"allComputers\":['+$allComputers+'],\"allUsers\":{'+$allUser" \
"s+'}}';write-output $json;exit;"

// Without SECTION 3 : OK
#define COMPUTERSANDUSERS_PS1_NO3 \
"function abort($code, $desc) {$json='{\"errorCode\":'+$code+',\"errorDesc\"" \
":\"'+$desc+'\",\"allComputers\":[],\"allUsers\":{}}';write-output $json;exi" \
"t;}function ldapID($dn) {$rep=@();$rdn=$dn -split ',';foreach($r in $rdn){$" \
"nv=$r -split '=';$rep+=,@($nv[0],$nv[1]);}$rep;}$computersdn=(Get-ADCompute" \
"r -Filter * -SearchBase \"OU=Workstation,OU=MyApp,DC=mydomain,DC=local\").D" \
"istinguishedName;if(-not $?){abort 1 \"Error in Get-ADComputer\";}if($compu" \
"tersdn.Length -eq 0){$allComputers='';}else{$_allComputers=@();foreach($cdn" \
" in $computersdn){$c=ldapID $cdn;if($c[0][0] -ne 'CN' -or $c[1][0] -ne 'OU'" \
"){abort 2 \"Invalid LDAP name\";}$computerName=$c[0][1];$loggedOnUser=(Get-" \
"WmiObject -ComputerName \"$computerName\" -Class Win32_ComputerSystem).User" \
"Name;if(-not $?){abort 3 \"Error in Get-WmiObject\";}$ipAddress=(Get-ADComp" \
"uter -Filter \"Name -eq '$computerName'\" -Properties IPv4Address).Ipv4Addr" \
"ess;if(-not $?) {abort 5 \"Error in Get-ADComputer\";}if ($loggedOnUser.Len" \
"gth -gt 0 -and $loggedOnUser.LastIndexOf('\') -ge 0){$loggedOnUser=$loggedO" \
"nUser.Substring($loggedOnUser.LastIndexOf('\') + 1);}$_allComputers+='{\"na" \
"me\":\"'+$computerName+'\",\"ipAddress\":\"'+$ipAddress+'\",\"role\":\"'+$c" \
"[1][1]+'\",\"loggedOnUser\":\"'+$loggedOnUser+'\"}';}$allComputers=$_allCom" \
"puters -join ',';}$allUsers='';$json='{\"errorCode\":0,\"errorDesc\":\"\",\"" \
"allComputers\":['+$allComputers+'],\"allUsers\":{'+$allUsers+'}}';write-out" \
"put $json;exit;"

// Without SECTION 2 : OK
#define COMPUTERSANDUSERS_PS1_NO2 \
"function abort($code, $desc) {$json='{\"errorCode\":'+$code+',\"errorDesc\"" \
":\"'+$desc+'\",\"allComputers\":[],\"allUsers\":{}}';write-output $json;exi" \
"t;}function ldapID($dn) {$rep=@();$rdn=$dn -split ',';foreach($r in $rdn){$" \
"nv=$r -split '=';$rep+=,@($nv[0],$nv[1]);}$rep;}$allComputers='';$users=(Ge" \
"t-ADUser -Filter * -SearchBase \"OU=ADU,OU=User,OU=MyApp,DC=mydomain,DC=loc" \
"al\");if(-not $?){abort 6 \"Error in Get-ADUser\";}if($users.Length -eq 0){" \
"$allUsers='';}else{$_allUsers=@();foreach($usr in $users){$userName=$usr.Us" \
"erPrincipalName.Substring(0, $usr.UserPrincipalName.IndexOf('@'));$ldapName" \
"=$usr.DistinguishedName;$u=ldapID $ldapName;if($u[0][0] -ne 'CN'){abort 7 \"" \
"Invalid LDAP name\";}$fullName=$u[0][1];$groupsdn=(Get-ADPrincipalGroupMemb" \
"ership -Identity \"$ldapName\").DistinguishedName;if(-not $?){abort 8 \"Err" \
"or in Get-ADPrincipalGroupMembership\";}if($groupsdn.Length -eq 0){$userRol" \
"es='';}else{$_userRoles=@();foreach($gdn in $groupsdn){$g=ldapID $gdn;if($g" \
"[0][0] -ne 'CN'){abort 9 \"Invalid LDAP name\";}$_userRoles+=$g[0][1];}$use" \
"rRoles='\"'+($_userRoles -join '\",\"')+'\"';}$_allUsers+='\"'+$userName+'\"" \
":{\"name\":\"'+$fullName+'\",\"roles\":['+$userRoles+']}';}$allUsers=$_allU" \
"sers -join ',';}$json='{\"errorCode\":0,\"errorDesc\":\"\",\"allComputers\"" \
":['+$allComputers+'],\"allUsers\":{'+$allUsers+'}}';write-output $json;exit" \
";"


MainQ::MainQ(QObject *parent) : QObject(parent)
{
    //qDebug() << __func__;

    // Direct sync command
    p_command = new Command(this);
    p_command->setTimeout(5); //5 seconds
    p_commandTimer = new QTimer(this);
    p_commandTimer->setTimerType(Qt::TimerType::VeryCoarseTimer);
    p_commandTimer->setInterval(3000); //3 seconds
    p_commandTimer->setSingleShot(false);
    connect(p_commandTimer, &QTimer::timeout, this, &MainQ::directSyncCommand);

    // Worker sync command
    p_workerThread = new QThread(this);
    p_worker = new Worker();
    p_worker->moveToThread(p_workerThread);
    // When thread finishes executing it destroys worker
    connect(p_workerThread, &QThread::finished, p_worker, &QObject::deleteLater);
    // REQ : MainQ -> Worker
    connect(this, &MainQ::runWorkerCommand, p_worker, &Worker::runCommand);
    // RES : Worker -> MainQ
    connect(p_worker, &Worker::replyReady, this, &MainQ::handleWorkerReply);
    // Starts thread event loop
    p_workerThread->start();

    // Invoke worker's method in worker's thread
    QMetaObject::invokeMethod(p_worker, [this]() {
        p_worker->setNowCommand(PS1_NOW);
    });

    p_workerTimer = new QTimer(this);
    p_workerTimer->setTimerType(Qt::TimerType::VeryCoarseTimer);
    p_workerTimer->setInterval(3000); //3 seconds
    p_workerTimer->setSingleShot(false);
    connect(p_workerTimer, &QTimer::timeout, [this]() {
        emit runWorkerCommand(COMPUTERSANDUSERS_PS1);
    });

    // RUN MODE 1 : Direct sync command ///////////////////////////////////////
    //directSyncCommand();
    //p_commandTimer->start();

    // RUN MODE 2 : Worker sync command ///////////////////////////////////////
    emit runWorkerCommand(COMPUTERSANDUSERS_PS1);
    p_workerTimer->start();
}

MainQ::~MainQ()
{
    //qDebug() << __func__;
    if (p_command) {
        p_command->deleteLater();
    }
    if (p_commandTimer) {
        p_commandTimer->stop();
        //p_commandTimer->disconnect();
        p_commandTimer->deleteLater();
    }
    //p_worker destroyed by QThread::finished()
    if (p_workerThread) {
        p_workerThread->quit();
        p_workerThread->wait();
        p_workerThread->deleteLater();

    }
    if (p_workerTimer) {
        p_workerTimer->stop();
        //p_workerTimer->disconnect();
        p_workerTimer->deleteLater();
    }
}

void MainQ::directSyncCommand()
{
    //qDebug() << __func__;
    p_command->set(COMPUTERSANDUSERS_PS1);

    if (p_command->syncExecute()) {
        qInfo() << "REPLY :" << QString(p_command->output()).trimmed();
    }
    else {
        p_commandTimer->stop();
        qWarning() << "syncExecute error" << (p_command->error()).trimmed()
                   << "in command" << (p_command->get()).trimmed();
        return;
    }

    p_command->set(PS1_NOW);

    if (p_command->syncExecute()) {
        qInfo() << "NOW :" << QString(p_command->output()).trimmed();
    }
    else {
        p_commandTimer->stop();
        qWarning() << "syncExecute error" << p_command->error().trimmed()
                   << "in command" << p_command->get().trimmed();
        return;
    }
}

void MainQ::handleWorkerReply(QString reply)
{
    qInfo() << "FULL REPLY :" << reply;
}
