#pragma once

#include <QObject>

#include <Command.hpp>

class Worker : public QObject
{
    Q_OBJECT
public:
    explicit Worker(QObject *parent = nullptr);
    virtual ~Worker();

    void setNowCommand(QString nowCommand);

signals:
    void replyReady(QString reply);

public slots:
    void runCommand(QString command);

private:
    Command *p_command;
    QString m_nowCommand;
    QString m_reply;
};
